#include <iostream>
#include <cmath>
#include "freakture.h"
#include "freaktory.h"
#include "setup.h"

freaktory::freaktory()
{

}

freaktory::~freaktory()
{

}

void freaktory::SetRandomStartPos(freakture& Fsp)
{
	Fsp.SetPosX(((float)rand()/RAND_MAX)*WIDTH);  //some position within the
	Fsp.SetPosY(((float)rand()/RAND_MAX)*HEIGHT); //window's area
}

void freaktory::SetRandomStartRot(freakture& Fsr)
{
	Fsr.SetRot(((float)rand()/RAND_MAX)*360); //random rotation up to 360 deg
}

void freaktory::SetRandomStartHeading(freakture& Fsh)
{
	Fsh.SetHeadingX(cos(Fsh.GetRot()*DEGTORAD)); // rot * Pi/180
	Fsh.SetHeadingY(sin(Fsh.GetRot()*DEGTORAD));
}

void freaktory::SetRandomTrailColour(freakture& Fstc)
{
	Fstc.COLOUR.r = ((float)rand()/RAND_MAX);
	Fstc.COLOUR.g = ((float)rand()/RAND_MAX);
	Fstc.COLOUR.b = ((float)rand()/RAND_MAX);
}

void freaktory::SpawnFreakture()
{
		freakture* current;
		current = new freakture; //create a new one
		
		Freaktures.push_back(*current); //dereference so actual information is copied over

		delete current; //delete temp one before leaving loop.  all gone!
}

void freaktory::Populate(int Pop)
{
	int i;
	
	for(i=0;i<Pop;i++)
	{
		SpawnFreakture();
		SetRandomStartPos(Freaktures[i]);
		SetRandomStartRot(Freaktures[i]);
		SetRandomStartHeading(Freaktures[i]);
		SetRandomTrailColour(Freaktures[i]);
	}
}

int freaktory::GetPopulation()
{
	return Freaktures.size();
}

void freaktory::KillFreakture()
{
	//code here to destroy/kill any given freakture and clean up
}

