#include <iostream>
#include <vector>
#include <cmath>
#include "movement.h"
#include "freakture.h"
#include "freaktory.h"
#include "setup.h"

movement::movement()
{
	
}

movement::~movement()
{
	
}

void movement::SetRandomRot(freakture& SRR)
{
	SRR.SetRot((((float)rand()/RAND_MAX)*360)-180);	
}

int movement::CheckBoundaries(freakture& FsB)
{
	if(FsB.GetPosX()>0 && FsB.GetPosX()<WIDTH && FsB.GetPosY()>0 && FsB.GetPosY()<HEIGHT)
		return 0; //freakture is totally inside the boundaries
	else
		return 1; //freakture is outside both X and Y boundaries
}

void movement::SetHeading(freakture& FsH)
{
	FsH.SetHeadingX(cos(FsH.GetRot()*DEGTORAD)); //rot in rads = deg*(pi/180)
	FsH.SetHeadingY(sin(FsH.GetRot()*DEGTORAD));	
}

void movement::SetNewPosition(freakture& FsP)
{
	//freakture's speed multiplyer thingy =>  heading*speed*time
	FsP.SetPosX(FsP.GetPosX()+(FsP.GetHeadingX()*FsP.GetSpeed()*setup::current_time));
	FsP.SetPosY(FsP.GetPosY()+(FsP.GetHeadingY()*FsP.GetSpeed()*setup::current_time));
}


void movement::Restless(freakture& FsR)
{
	if(((float)rand()/RAND_MAX)<0.01)
	{
		SetRandomRot(FsR);
		SetHeading(FsR);
	}	
}

void movement::Amble(freakture& FsAmb)
{
	//set a smooth rotation to the movements
}

void movement::HeadToCentre(freakture& FsC)
{
	float length, tempX, tempY;
	//get the vector from freaktures position to the centre
	tempX=CENTREX-FsC.GetPosX();
	tempY=CENTREY-FsC.GetPosY();
	//set the heading to the normalized vector
	//to normalize, find the length of the vector => sqrt(x*x+y*y)
	//divide each component by the length.
	length=sqrt((tempX*tempX)+(tempY*tempY));
	FsC.SetHeadingX(tempX/length);
	FsC.SetHeadingY(tempY/length);
}



void movement::UpdateMoves(std::vector<freakture>& Fs3)
{
	unsigned int i;
	
	for(i=0;i<Fs3.size();i++)
	{
		Fs3[i].SetLastPosX(Fs3[i].GetPosX());
		Fs3[i].SetLastPosY(Fs3[i].GetPosY());
		if(CheckBoundaries(Fs3[i])==0)
			Restless(Fs3[i]);
		else
			HeadToCentre(Fs3[i]);
		SetNewPosition(Fs3[i]);
	}
}


