#include <iostream>
#include <cmath>
#include "test_freakture.h"
#include "test_freaktory.h"
#include "test_setup.h"

freaktory::freaktory()
{

}

freaktory::~freaktory()
{

}

void freaktory::SetRandomStartPos(freakture& Fsp)
{
	Fsp.SetPosX(((float)rand()/RAND_MAX)*WIDTH); //some position within the
	Fsp.SetPosY(((float)rand()/RAND_MAX)*HEIGHT); //window's area
}

void freaktory::SetRandomStartRot(freakture& Fsr)
{
	Fsr.SetRot(((float)rand()/RAND_MAX)*360); //rotate up to 10 in either direction?
}

void freaktory::SetRandomStartHeading(freakture& Fsh)
{
	Fsh.SetHeadingX(cos(Fsh.GetRot()*DEGTORAD)); // rot * Pi/180
	Fsh.SetHeadingY(sin(Fsh.GetRot()*DEGTORAD));
	Fsh.SetLastHeadingX(Fsh.GetHeadingX());
	Fsh.SetLastHeadingY(Fsh.GetHeadingY());
}

void freaktory::SetRandomTrailColour(freakture& Fstc)
{
	Fstc.COLOUR.r = ((float)rand()/RAND_MAX);
	Fstc.COLOUR.g = ((float)rand()/RAND_MAX);
	Fstc.COLOUR.b = ((float)rand()/RAND_MAX);
}

void freaktory::SpawnFreakture()
{
		freakture* current;
		current = new freakture; //create a new one
		
		//SetRandomStartRot(current); //set a random rotation but not position
		
		Freaktures.push_back(*current); //dereference so actual information is copied over

		//std::cout<<Freaktures.size()<<std::endl;
		delete current; //delete temp one before leaving loop.  all gone!
}

void freaktory::Populate(int Pop)
{
	int i;
	
	for(i=0;i<Pop;i++)
	{
		SpawnFreakture();
		SetRandomStartPos(Freaktures[i]);
		SetRandomStartRot(Freaktures[i]);
		SetRandomStartHeading(Freaktures[i]);
		SetRandomTrailColour(Freaktures[i]);
		//Freaktures[i].Print();
	}
}

int freaktory::GetPopulation()
{
	//std::cout<<"Population stands at "<<Fs.size()<<std::endl;
	return Freaktures.size();
}

void freaktory::KillFreakture()
{
	//code here to destroy/kill any given freakture and clean up
}

