#include <iostream>
#include <ctime>
#include "test_freakture.h"
#include "test_freaktory.h"
#include "test_setup.h"
#include "test_renderer.h"
#include "test_movement.h"
#include "test_frinteract.h"

using namespace std;

int main()
{
	//int i;
	int initPop = 5;
	
	srand(time(NULL)); //set random seed based on the time
	
	freaktory Factory; //object of type freaktory, called Factory
	setup SetUp;	   //object of type setup, called SetUp
	renderer Rend;	   //object of type renderer, called Rend
	movement Move;	   //object of type movement, called Move
	frinteract Frint; //object of type frinteract, called Frint
	
	Factory.Populate(initPop); //create initial freakture population

	//set up all SDL stuff for drawing the window
	if(SetUp.SDL_Setup())
	{
		cout<<"Error initializing SDL"<<endl;	
	}
	
	Rend.GL_Setup();
	
	
	SetUp.SetLastTime();
	
	//keep the window there until the user exits
	while(SetUp.active)
	{
		SetUp.UpdateTime();
		SetUp.event();
		Frint.SetTrails(Factory.Freaktures);
		Move.UpdateMoves(Factory.Freaktures);
		Rend.Draw_All(Factory.Freaktures);
		//SetUp.SetLastTime();
	}
	
	std::cout<<"moved: "<<std::endl;
	
	//for now, cycle through and print info of all freaktures
	/*for(i=0;i<Factory.GetPopulation();i++)
	{
		Factory.Freaktures[i].Print();
	}*/
		
	//std::cout<<"Population stands at "<<Fs.size()<<std::endl;
	
	return 0;

}

