#include <iostream>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <vector>
#include "test_renderer.h"
#include "test_setup.h"
//#include "test_freaktory.h"
//#include "test_freakture.h"

using namespace std;

renderer::renderer()
{
	
}

renderer::~renderer()
{
	
}

void renderer::GL_Setup()
{
	glClearColor(0.0,0.0,0.0,0.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	//glOrtho(left,right,bottom,top,znear,zfar)
	glOrtho(-10,WIDTH+10,-10,HEIGHT+10,-10,10);
	
	//gluPerspective(45.0f, WIDTH/HEIGHT, 0.1f, 800.0f);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void renderer::Draw_Freakture(freakture& FsDF)
{
	glBegin(GL_POLYGON);
		glColor3f(0.0,0.0,1.0);
		//glVertex2f(0.0,(FsDF.GetSize()*2));//weird shape
		glVertex2f(-(FsDF.GetSize()),-(FsDF.GetSize()));
		glVertex2f(-(FsDF.GetSize()),FsDF.GetSize());
		glVertex2f(FsDF.GetSize(),FsDF.GetSize());
		glVertex2f(FsDF.GetSize(),-(FsDF.GetSize()));
	glEnd();	
}

void renderer::Draw_Trails(freakture& FsDT)
{
	glPointSize(3.0);
	glBegin(GL_POINTS);
		glColor3f(FsDT.COLOUR.r,FsDT.COLOUR.g,FsDT.COLOUR.b);
		glVertex2f(0.0,0.0);
	glEnd();
}

void renderer::Draw_All(std::vector<freakture>& Fs2)
{
	unsigned int i;
	unsigned int j;
	
	glLoadIdentity();
	
	gluLookAt(0,0,1,
			  0,0,0,
			  0,1,0);
			  
	glClear(GL_COLOR_BUFFER_BIT);
	
	for(i=0;i<Fs2.size();i++)
	{
		glPushMatrix();
			glTranslatef((float)Fs2[i].GetPosX(),(float)Fs2[i].GetPosY(),0.0);
			glRotatef(Fs2[i].GetRot(),0.0,0.0,1.0);
			Draw_Freakture(Fs2[i]);
		glPopMatrix();
		
		for(j=0;j<Fs2[i].Trail.size();j+=2)
		{
			if(j>2)
			{
				glPushMatrix();
					glTranslatef(Fs2[i].Trail[j].x,Fs2[i].Trail[j].y, 0.0);
					Draw_Trails(Fs2[i]);
				glPopMatrix();
			}
		}
				
	}
		
	glFlush();
	SDL_GL_SwapBuffers();
}
