#include <iostream>
#include <SDL/SDL.h>
#include "test_setup.h"

using namespace std;

unsigned int setup::current_time = 0;
unsigned int setup::last_time = 0;

int setup::active = 0;

setup::setup()
{
	
}

setup::~setup()
{
	SDL_Quit();	
}

int setup::SDL_Setup()
{
	const SDL_VideoInfo* info = NULL;
	
	if(SDL_Init(SDL_INIT_VIDEO) !=0)
	{
		cout<<"error init-ing sdl video"<<endl;
		return 1;	
	}
	
	info = SDL_GetVideoInfo();
	
	SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
	
	if(SDL_SetVideoMode(WIDTH, HEIGHT, info->vfmt->BitsPerPixel,SDL_OPENGL)==0)
	{
		cout<<"error setting video mode"<<endl;
		return 1;	
	}
	
	active = 1;
	
	return 0;
}

void setup::UpdateTime()
{
	current_time=SDL_GetTicks()-last_time;
	last_time = SDL_GetTicks();
}

void setup::SetLastTime()
{
	last_time = SDL_GetTicks();
}

void setup::event()
{
	SDL_Event evt;
	
	while(SDL_PollEvent(&evt))
	{
		switch(evt.type)
		{
			case SDL_QUIT:
				active = 0;
				break;
			default:
				break;	
		}
	}	
}

